
#include <ESP8266WiFi.h>


#define btn0 16
#define btn1 5
#define btn2 4
#define btn3 0


const char *ssid = "ssid";
const char *password = "password";


int buttonValue0 = 0;       //button value, I'm usingg 0/1 button state
int buttonValue1 = 0;        
int buttonValue2 = 0;        
int buttonValue3 = 0;       

void setup() {
  Serial.begin(115200);
  delay(10);

  pinMode(btn0, INPUT);
  pinMode(btn1, INPUT);
  pinMode(btn2, INPUT);
  pinMode(btn3, INPUT);


  // set the ESP8266 to be a WiFi-client
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
  }

}

void loop() {
if(digitalRead(btn0) == LOW) buttonValue0 = 1;
if(digitalRead(btn1) == LOW) buttonValue1 = 1;
if(digitalRead(btn2) == LOW) buttonValue2 = 1;
if(digitalRead(btn3) == LOW) buttonValue3 = 1;

if(digitalRead(btn0) == HIGH) buttonValue0 = 0;
if(digitalRead(btn1) == HIGH) buttonValue1 = 0;
if(digitalRead(btn2) == HIGH) buttonValue2 = 0;
if(digitalRead(btn3) == HIGH) buttonValue3 = 0;


  // Use WiFiClient class to create TCP connections
  WiFiClient client;
  const char * host = "192.168.4.1";            //default IP address
  const int httpPort = 80;

  if (!client.connect(host, httpPort)) {
    Serial.println("connection failed");
    return;
  }

  // We now create a URI for the request. Something like /data/?button_reading=123
  String url = "/data/";
  url += "?button_reading=";
  url +=  "{\"button0_reading\":\"button0_value\",\"button1_reading\":\"button1_value\",\"button2_reading\":\"button2_value\",\"button3_reading\":\"button3_value\"}";

  url.replace("button0_value", String(buttonValue0));
  url.replace("button1_value", String(buttonValue1));
  url.replace("button2_value", String(buttonValue2));
  url.replace("button3_value", String(buttonValue3));


  // This will send the request to the server
  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" +
               "Connection: close\r\n\r\n");
  unsigned long timeout = millis();
  while (client.available() == 0) {
    if (millis() - timeout > 5000) {
      Serial.println(">>> Client Timeout !");
      client.stop();
      return;
    }
  }
}
